#include "counter.h"


int main(int argc, char *argv[])
{
	Counter a("a");
	Counter b("b");
	
//	QObject::connect(&a, SIGNAL(valueChanged(int)),
//	              &b, SLOT(setValue(int)));
//	QObject::connect(&b, SIGNAL(valueChanged(int)),
//	              &a, SLOT(setValue(int)));
	boost::signals::connection ca =
		 a.valueChanged.connect(
			boost::bind(&Counter::setValue, &b, _1));
	boost::signals::connection cb =
		b.valueChanged.connect(
			boost::bind(&Counter::setValue, &a, _1));

	a.clear();
	b.clear();
	
	a.setValue(12);
	b.setValue(48);

	a.valueChanged.disconnect(boost::bind(&Counter::setValue, &b, _1));
	b.valueChanged.disconnect(boost::bind(&Counter::setValue, &a, _1));

	//	boost 1.4.0
	a.valueChanged2.connect(
		boost::bind(&Counter::setValue2, &b, _1));
	b.valueChanged2.connect(
		boost::bind(&Counter::setValue2, &a, _1));
	
	a.clear();
	b.clear();
	
	a.setValue(9);
	b.setValue(10);

	a.clear();
	b.clear();
	
	a.setValue2(9);
	b.setValue2(10);

	
	return 1;
}

